sc::SavableState(3)

NAME
sc::SavableState - Base class for objects that can save/restore state.

SYNOPSIS

#include <state.h>

Inherits sc::DescribedClass.

Inherited by sc::AccumH [virtual], sc::AngularIntegrator [virtual], sc::AtomInfo, sc::Convergence [virtual], sc::Debugger, sc::DenFunctional [virtual], sc::DenIntegrator [virtual], sc::Function [virtual], sc::GaussianBasisSet, sc::GaussianShell, sc::HessianUpdate [virtual], sc::IntCoor, sc::IntCoorGen, sc::Integral, sc::IntegrationWeight [virtual], sc::MOIndexSpace [virtual], sc::MOIntsTransformFactory [virtual], sc::MolecularCoor, sc::MolecularFrequencies, sc::MolecularHessian [virtual], sc::Molecule, sc::MP2R12Energy [virtual], sc::Optimize [virtual], sc::OverlapOrthog [virtual], sc::PointGroup, sc::R12IntEval [virtual], sc::R12IntEvalInfo [virtual], sc::R12IntsAcc [virtual], sc::RadialIntegrator [virtual], sc::SCBlockInfo, sc::SCDimension, sc::SCElementOp, sc::SCElementOp2, sc::SCElementOp3, sc::SCExtrapData, sc::SCExtrapError, sc::SCMatrixBlock, sc::SCMatrixBlockList, sc::SelfConsistentExtrapolation, sc::SetIntCoor, sc::ShellPairCints [virtual], sc::ShellPairsCints [virtual], sc::TwoBodyGrid [virtual], sc::TwoBodyMOIntsTransform [virtual], and sc::Units.

  Public Member Functions
SavableState & operator= (const SavableState &)
void save_state (StateOut &)
Save the state of the object as specified by the StateOut object.
void save_object_state (StateOut &)
This can be used for saving state when the exact type of the object is known for both the save and the restore.
virtual void save_vbase_state (StateOut &)
Save the virtual bases for the object.
virtual void save_data_state (StateOut &)
Save the base classes (with save_data_state) and the members in the same order that the StateIn CTOR initializes them.

  Static Public Member Functions
static void save_state (SavableState *s, StateOut &)
static SavableState * restore_state (StateIn &si)
Restores objects saved with save_state.
static SavableState * key_restore_state (StateIn &si, const char *keyword)
Like restore_state, but keyword is used to override values while restoring.
static SavableState * dir_restore_state (StateIn &si, const char *objectname, const char *keyword=0)

  Protected Member Functions
SavableState (const SavableState &)
SavableState (StateIn &)
Each derived class StateIn CTOR handles the restore corresponding to calling save_object_state, save_vbase_state, and save_data_state listed above.

Detailed Description

Base class for objects that can save/restore state.

Constructor & Destructor Documentation

  sc::SavableState::SavableState (StateIn &) [protected]

Each derived class StateIn CTOR handles the restore corresponding to calling save_object_state, save_vbase_state, and save_data_state listed above.

All derived class StateIn& constructors must invoke the SavableState(StateIn&) constructor.

Member Function Documentation

  void sc::SavableState::save_state (StateOut &)

Save the state of the object as specified by the StateOut object.

This routine saves the state of the object (which includes the nonvirtual bases), the virtual bases, and type information. The default implementation should be adequate.

  void sc::SavableState::save_object_state (StateOut &)

This can be used for saving state when the exact type of the object is known for both the save and the restore.

To restore objects saved in this way the user must directly invoke the object's StateIn& constructor.

  virtual void sc::SavableState::save_vbase_state (StateOut &) [virtual]

Save the virtual bases for the object.

This must be done in the same order that the ctor initializes the virtual bases. This does not include the DescribedClass and SavableState virtual base classes. This must be implemented by the user if the class has other virtual bases. (These virtual bases must come after SavableState, if SavableState is virtual.)

  virtual void sc::SavableState::save_data_state (StateOut &) [virtual]

Save the base classes (with save_data_state) and the members in the same order that the StateIn CTOR initializes them.

This must be implemented by the derived class if the class has data.

Reimplemented in sc::AtomInfo, sc::IntCoor, sc::SumIntCoor, sc::SetIntCoor, sc::IntCoorGen, sc::MolecularCoor, sc::IntMolecularCoor, sc::SymmMolecularCoor, sc::RedundMolecularCoor, sc::CartMolecularCoor, sc::MolecularEnergy, sc::FinDispMolecularHessian, sc::MolecularHessian, sc::ReadMolecularHessian, sc::GuessMolecularHessian, sc::DiagMolecularHessian, sc::Molecule, sc::MolecularFrequencies, sc::SimpleCo, sc::GaussianBasisSet, sc::GaussianShell, sc::Integral, sc::OverlapOrthog, sc::IntegralCints, sc::ShellPairCints, sc::ShellPairsCints, sc::CLKS, sc::DenFunctional, sc::NElFunctional, sc::SumDenFunctional, sc::StdDenFunctional, sc::LSDACFunctional, sc::PBECFunctional, sc::PW91CFunctional, sc::P86CFunctional, sc::SlaterXFunctional, sc::VWNLCFunctional, sc::VWN1LCFunctional, sc::VWN2LCFunctional, sc::VWN3LCFunctional, sc::VWN4LCFunctional, sc::VWN5LCFunctional, sc::PW92LCFunctional, sc::PZ81LCFunctional, sc::XalphaFunctional, sc::Becke88XFunctional, sc::LYPCFunctional, sc::PW86XFunctional, sc::PBEXFunctional, sc::PW91XFunctional, sc::mPW91XFunctional, sc::G96XFunctional, sc::HSOSKS, sc::DenIntegrator, sc::IntegrationWeight, sc::BeckeIntegrationWeight, sc::RadialIntegrator, sc::AngularIntegrator, sc::EulerMaclaurinRadialIntegrator, sc::LebedevLaikovIntegrator, sc::GaussLegendreAngularIntegrator, sc::RadialAngularIntegrator, sc::UKS, sc::IntegralCCA, sc::IntegralV3, sc::MBPT2, sc::MBPT2_R12, sc::MOIndexSpace, sc::MP2R12Energy, sc::R12IntsAcc, sc::R12IntEval, sc::MOIntsTransformFactory, sc::TwoBodyMOIntsTransform_ijxy, sc::TwoBodyMOIntsTransform_ikjy, sc::TwoBodyMOIntsTransform_ixjy, sc::TwoBodyMOIntsTransform, sc::TwoBodyGrid, sc::R12IntEvalInfo, sc::PsiWavefunction, sc::PsiSCF, sc::PsiCCSD, sc::PsiCCSD_T, sc::CLHF, sc::CLSCF, sc::HSOSHF, sc::HSOSSCF, sc::SCF, sc::UHF, sc::UnrestrictedSCF, sc::OneBodyWavefunction, sc::Wavefunction, sc::Convergence, sc::DIIS, sc::EFCOpt, sc::Function, sc::Optimize, sc::LineOpt, sc::QNewtonOpt, sc::SCExtrapData, sc::SCExtrapError, sc::SelfConsistentExtrapolation, sc::HessianUpdate, sc::DFPUpdate, sc::BFGSUpdate, sc::PowellUpdate, sc::SCMatrixBlock, sc::SCVectorSimpleBlock, sc::SCVectorSimpleSubBlock, sc::SCMatrixRectBlock, sc::SCMatrixRectSubBlock, sc::SCMatrixLTriBlock, sc::SCMatrixLTriSubBlock, sc::SCMatrixDiagBlock, sc::SCMatrixDiagSubBlock, sc::SCBlockInfo, sc::SCDimension, sc::SCElementKNorm, sc::PointGroup, sc::Debugger, and sc::Units.

  static SavableState* sc::SavableState::restore_state (StateIn & si) [static]

Restores objects saved with save_state.

The exact type of the next object in si can be any type publically derived from the SavableState. Derived classes implement a similar static function that returns a pointer to the derived class. If the objectname is given the directory will be consulted to find and restore that object.

  static SavableState* sc::SavableState::key_restore_state (StateIn & si, const char * keyword) [static]

Like restore_state, but keyword is used to override values while restoring.

Author

Generated automatically by Doxygen for MPQC from the source code.